function ET0 = fao_Snyder_greenhouse_DLC_R_Rain_source_Fernand(Tmean_C,RH,WindSp_ms,RadGlo_Wm2,Date)
% ii=61+60*10
% Tmean_C = Tin(ii)
% RH=RHin(ii)
% WindSp_ms=myWout(ii)
% RadGlo_Wm2=qgrin(ii)
% Date=tspan_date(ii)
pi = 3.14159265359; % pi greco
%%% EQ38 albedo
a = 0.23; % reference grass
% Davis
latdeg = 40+57/60 ;% latitude in degrees e.g. 47?36'
altit = 10; % m
%%% EQ31
long_stat = (360- (14+9/60)); %long 9?17'
long_tz = 360-15; % in ° half of the time zone, west of Greenwhich
t1 = 1; % step is 1 hour, 0.5 for 30 minutes
% Lz longitude of the centre of the local time zone [degrees west of Greenwich]. For example, Lz = 75, 90, 105 and 120° for the Eastern, Central, Rocky Mountain and Pacific time zones (United States) and Lz = 0° for Greenwich, 330° for Cairo (Egypt), and 255° for Bangkok (Thailand),
% Lm longitude of the measurement site [degrees west of Greenwich],

% dewpoint temperature measured here, not in Eschelisbach so keep recalculated
Tdew_C = Tmean_C - ((100 - RH)/5);

Tmean = Tmean_C; % °C
Tdew = Tdew_C; % °C
Windsp = WindSp_ms; % m/s
Rs = RadGlo_Wm2 * 0.0036; % W/m2 to MJ/m2/h % MeteoSwiss call it like this

%%%
ciccio = char(Date);
ciccio = str2num(ciccio(12:13));
myt = ciccio;
myt = myt + 0.5;
doy = day(Date,'dayofyear'); % first day of the year is 0, thus I add 1
RH = [];


%%% STEP 1
%% calculate Ra (Extraterrestrial radiation)
% EQ28 solar constant
G_SC = 0.082; % MJ / m2 / min %%
%%% Boltzmann
sigma_BS = 2.04 * 1e-10; % MJ / hours / m2 / °K4
% EQ22 Latitude in radians converted from latitude (L) in degrees
fi = +pi/180 * latdeg; % rad OK
%%% EQ23 correction for eccentricity of Earth's orbit around the sun
dr = 1 + 0.033 * cos(2*pi/365 * doy);
%%% EQ 24 Declination of the sun above the celestial equator in radians
delta = 0.409 * sin(2*pi/365 *doy - 1.39);

%%% EQ33
b = 2*pi*(doy-81) / 364;

%%% EQ32 solar time correction for wobble in Earth's rotation
SC = 0.1645 * sin(2*b) - 0.1255 * cos(b) - 0.025 * sin(b);

%%% EQ31 hour angle in radians
omega = pi/12 * ((myt) + (long_tz-long_stat)/15 + SC - 12  );

%%% EQ29
omega_1 = omega - t1*pi/24;
%%% EQ30
omega_2 = omega + t1*pi/24;

%%% EQ25
omega_s = acos(-tan(fi)*tan(delta));

%nighttime
j = find(omega < -1*omega_s | omega > omega_s); % sun below the horizon (nighttime) % FAO
if (sum(j)>0)
    omega_1(j) = 0;
    omega_2(j) = 0;
end

% EQ 28 for hourly data
Ra = 12/pi *G_SC*60 * dr * ( (omega_2-omega_1)*sin(fi)*sin(delta) + ...
    cos(fi)*cos(delta)*(sin(omega_2)-sin(omega_1)) );
jRa = find(Ra < 0);
if length(jRa) > 0
    Ra(jRa) = 0;
    % print(paste0("Ra less than 0 for ", length(jRa), " times"), sep="");
end
% beta = 180/pi * asin(sin(fi)*sin(delta) + cos(fi)*cos(delta)*cos(omega)) %%%%%%%%%%%%%%%%% fAO does not use it


%%% STEP2
%%% EQ37 clear sky total global solar radiation at the Earth's surface in MJ m-2 h-1
Rso = (0.75 + 2*1e-5 * altit) * Ra;
%%%
es = 0.6108 * exp((17.27 * Tmean)/(Tmean + 237.3)); % saturation vapor pressure (kPa)
% ea = es * RH /100
% if (!is.null(Tdew)) {
%     ea = 0.6108 * exp((17.27 * Tdew)/(Tdew + 237.3)) % actual vapor pressure (kPa)
%     } else if (!is.null(Tmean)) {
%         ea = es * RH /100
%         }
ea = 0.6108 * exp((17.27 * Tdew)/(Tdew + 237.3)); % actual vapor pressure (kPa)

%%% apparent net clear sky emissivity
eps = 0.34-0.14*sqrt(ea);
%%% a cloudiness function of RS and RSO
Rs_Rso = Rs / Rso;
% nighttime
if (sum(j)>0)
    Rs_Rso(j) = 0.6; % semi-humid humid areas is 0.4-0.6 - for dry is 0.6-0.8. 0.3 means total cloud
end
f = 1.35 * Rs_Rso - 0.35; % OK
% FAO assumes Rs_Rso = 0.8 at night
%%% EQ38
Rns = (1-a) * Rs; % OK

sigma_BS_T4 = sigma_BS * (Tmean + 273.16)^4;

%%% EQ39
Rnl = sigma_BS_T4 * eps * f; % net longwave radiation [MJ/m2/h] OK

Rn = Rns - Rnl;


%%% STEP 3
%%% EQ50
% K_Rs = 0.16 % land
K_Rs = 0.19; % coastal areas, affected by large water bodies

%%% EQ8
cp = 0.001013; % MJ / kg °C OK
eps = 0.622; % (-) OK
lam = 2.45; % MJ / kg OK

%%% EQ8
P = 101.3 * ((293-0.0065*altit)/293)^(5.26); % [kPa] OK
gam = cp * P / (eps * lam); % kPa / °C OK

%%% EQ13
DELTA = 4098 *  es / (Tmean + 237.3)^2; % kPa / °C
% DELTA = (4098*0.6108*exp((17.27*Tmean)/(Tmean+237.3))) / (Tmean + 237.3)^2 % kPa / °C % OK


% daytime
G = 0.1*Rn;
% nighttime
if (sum(j)>0)
    G(j) = 0.5*Rn(j);
end


% daytime
% ET0 = ( 0.408*DELTA*(Rn-G) + gam*37*Windsp*(es-ea)/(Tmean+273.16) ) /(DELTA + gam*(1+0.24*Windsp))
%ET0 = ( 0.408*DELTA*(Rn-G) + gam*37*Windsp*(es-ea)/(Tmean+273.16) ) /(DELTA + gam*(1+0.34*Windsp));
% greenhouse Fernandez ra=295 not 208/u2 - so below seems wrong, it is just
% a lower windspees, perhaps considering that wind can go through the
% greenhouse
rsF =  3600*0.622/(1*0.287);
ET0 = ( 0.408*DELTA*(Rn-G) + gam*rsF/295*(es-ea)/(Tmean+273.16) ) /(DELTA + gam*(1+70/295));
% nigthtime
if (sum(j)>0)
    ET0(j) = ( 0.408*DELTA(j)*(Rn(j)-G(j)) + gam*rsF/295*(es(j)-ea(j))/(Tmean(j)+273.16) ) /(DELTA(j) + gam*(1+200/295));
end


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% print(paste0("length ET0 < 0 is ", sum(ET0<0), " out of ", length(ET0), sep=""))
% print(paste0("length ET0 < 0 is ", sum(ET0(j)<0), " out of ", length(j), " during night time", sep=""))
ET0(ET0<0) = 0;
ET0 = round(ET0, 2);

end